//This is the main file that puts everything together, large sections are put into thier own file
//Smaller sections are placed directly in this file

%module(directors="1") RakNet

#pragma SWIG nowarn=312,302,314,473

%include "RakNetCSharpCPlusIncludes.i"
//----------------Includes for swig functions -----------
%include cpointer.i
%include "arrays_csharp.i"
%include "typemaps.i"
%include "carrays.i"
//----------------------Features--------------------
//The director featur is required for C# function overrides to work on the C++ classes
%feature("director") NatPunchthroughDebugInterface;
%feature("director") FileListTransferCBInterface;
%feature("director") UDPProxyClientResultHandler;
%feature("director") UDPProxyServerResultHandler;
%feature("director") NetworkIDObject;

//----------------Extra Swig PreProcessor------------
%include "RakNetCSharpPreprocessor.i"

//----------Ignores----------------
%include "RakNetCSharpIgnores.i"

//------------------------------TypeMaps--------------------------
%include "RakNetCSharpTypeMaps.i"

//----------------------------Method modifiers---------------------
%include "RakNetCSharpMethodModifiers.i"

//--------------------------Renames--------------------------------
%include "RakNetCSharpRenames.i"

//--------------------------------Extends-----------------------------------
%include "RakNetCSharpExtends.i"

//----------------------------Additional Class/Struct Defines-----------------------
%include "RakNetStructsAndClasses.i"

//---------------------------Extra global functions---------------

//What these two functions are for, is to get around the string in/out problem I return the string
//These helper functions are hidden from the user, the user sees the original in/out api
//This is the C++ code insert
%{
char * StatisticsToStringHelper( RakNet::RakNetStatistics *s,char * buffer,int verbosityLevel )
{
	StatisticsToString( s, buffer, verbosityLevel );
	return buffer;
}

%}

//This code is for Swig parsing
char * StatisticsToStringHelper( RakNet::RakNetStatistics *s,char * buffer,int verbosityLevel )
{
	StatisticsToString( s, buffer, verbosityLevel );
	return buffer;
}

//------------------------------Header includes for parsing by swig----------------------------
%include "RakNetCSharpSwigIncludes.i"
using namespace RakNet;

//---------------------------------Template Defines-------------------------
%include "RakNetCSharpTemplateDefines.i"
